unit URainOffUtils;

interface

uses Dialogs, UDMRainOff;

const                         {tbv graphics}
  PosX1=70;
  PosX2=PosX1+500;
  PosY1=70;
  PosY2=PosY1+320;

var
    {Input}
  CalcMethod, ShortDir,
  AuxDir                 : string;
  CalcDone, Qtrend       : boolean;
    {Graphics}
  Ymax, Ymin, Xmax, Xmin,
  Yrmax, Yrmin, Ycmax, Ycmin,
  Zmax, Zmin, Hmax, Hmin       : real;
  Slope, XAv, YAv, StErr       : real;
  X1, X2, Y1, Y2, RunRef       :real;
  MaxY, MinY, MaxX, MinX,
  MaxZ, MinZ, MaxH, MinH       : longint;
  FactorY, FactorX,
  ScaleY, ScaleX, LX, LY,
  DecimY, DecimX, TrialNr      : integer;
  RelXdata, RelYdata,
  RelYrData, RelYcData,
  RelZdata, RelHdata           : array of integer;
  LegendX, LegendY,
  LegendX1, LegendY1,
  LegendX2, LegendY2,
  LegendX3, LegendY3,
  LegendZ                      : string;
  SumResSq13, SumResSq14,
  SumResSq15, SumResSq16,
  SumResSq17                   : real;
  InverseX, InverseY, NotFit,
  Halt                         : boolean;
  Trace                        : array [1..1501] of boolean;
  Rain, Run, Time, RunTr       : array [1..1501] of real;
  Xpoint, Quadr                : array [1..11] of real;
  RelXpoint, RelQuadr          : array [1..11] of integer;
  XpointRel, QuadrRel          : real;
  Acoeff, Bcoeff, Ccoeff       : real;
  A1Coeff, A2Coeff, B1Coeff, B2Coeff,
  C1Coeff, C2Coeff,  B1value, B2value  : real;

     {Input}
  procedure CheckData (var ItIsOK : boolean);

    {Graphics}
  procedure Regress;
  procedure MaxMin (var Choice : byte);
  procedure OrderData;
  procedure Relative (var Choice : byte);
  procedure Legends (var Choice : byte);

implementation


procedure Regress;

var
ZSum, ZSumSq     : real;
YSum, YSumsq     : real;
YZPr, YZRedPr    : real;
YRedSumSq, Zav   : real;
NumDat, kk         : integer;

begin

  NotFit   := false;
  ZSum    := 0;
  YSum     := 0;
  ZSumSq  := 0;
  YSumSq   := 0;
  YZPr    := 0;
  NumDat   := DMRainOff.NrOfData;


  for kk:=0 to Numdat-1 do with DMRainOff do
  begin
    ZSum   := ZSum   + Zdata[kk];
    YSum   := YSum   + Yrdata[kk];
    ZSumSq := ZSumSq + ZData[kk]*Zdata[kk];
    YSumSq := YSumSq + Yrdata[kk]*Yrdata[kk];
    YZPr := YZPr + Zdata[kk]*Yrdata[kk];
  end;

  YRedSumSq := YSumSq - YSum*YSum/NumDat;
  if YRedSumSq<=0 then
  begin
    NotFit:=true;
    exit;
  end;

  YAv       := YSum/NumDat;
  ZAv       := ZSum/NumDat;
  YZRedPr := YZPr - ZSum*YSum/NumDat;

  Slope := YZRedPr/YRedSumSq;
  StErr := exp(0.5*ln(YRedSumSq/(NumDat-1)));
  X1:=0;
  X2:=Xmax;
  Y1:=Slope*(X1-Yav)+Zav;
  Y2:=Slope*(Xmax-Yav)+Zav;

  for kk:=0 to 10 do
  begin
   Xpoint[kk+1]:=kk*Xmax/10;
   Quadr[kk+1]:=Acoeff*sqr(Xpoint[kk+1])+Bcoeff*Xpoint[kk+1]+Ccoeff;
  end;

end;
{end of Regress}
{--------------}


procedure CheckData (var ItIsOK : boolean);
var k : integer;
begin
  ItIsOk := true;
  Setlength (DMRainOff.SerialNr,DMRainOff.NrOfData+1);
  for k:=0 to DMRainOff.NrOfData-1 do with DMRainOff do
  begin
    if k<DMRainOff.NrOfData-1 then
       if Time[k]<Time[k+1] then SerialNr[k] := 1
       else SerialNr[k] := 2;
       SerialNr[DMRainOff.NrOfData-1] := 1;
    if Rain[k]>=0 then SerialNr[k] := 3
       else SerialNr[k] := 4;
    if Analysis then
       if Runoff[k]>=0 then SerialNr[k] := 5
       else SerialNr[k] := 6;
  end;
  for k:=0 to DMRainOff.NrOfData-1 do
    if DMRainOff.SerialNr[k] in [2,4,6] then ItIsOk := false;
end; {CheckData }

    {Graphics}

{MaxMin is part of Grafiek}
{-------------------------}
procedure MaxMin (var Choice : byte);

var k : integer;

begin
  Xmax := 0;
  Ymax := 0;
  Zmax := 0;
  YrMax:= 0;
  YcMax:= 0;
  Hmax := 0;
  Xmin := 10000000;
  Ymin := 10000000;
  Zmin := 10000000;
  YrMin:= 10000000;
  YcMin:= 10000000;
  HMin:= 10000000;

//  if Choice=5 then for k:=0 to DMRainOff.NrOfData-1 do with DMRainOff do
//     Hdata[k]:=Hdata[k];

  for k:=0 to DMRainOff.NrOfData-1 do with DMRainOff do
  begin
    if XData[k]>Xmax then Xmax := XData[k];
    if YData[k]>Ymax then Ymax := YData[k];
    if YrData[k]>Yrmax then YrMax := YrData[k];
    if YcData[k]>Ycmax then YcMax := YcData[k];
    if ZData[k]>Zmax then Zmax := ZData[k];
    if Choice=5 then
    if HData[k]>Hmax then Hmax := HData[k];
    if XData[k]<Xmin then Xmin := XData[k];
    if YData[k]<Ymin then Ymin := YData[k];
    if YrData[k]<YrMin then YrMin := YrData[k];
    if YcData[k]<Ycmin then YcMin := YcData[k];
    if ZData[k]<Zmin then Zmin := ZData[k];
    if Choice=5 then
    if HData[k]<Hmin then Hmin := HData[k];
  end;

  if (Choice=1) then
  begin
    Ymin := YcMin;
    Ymax := YcMax;
    if Zmin<Ymin then YMin := Zmin;
    if Zmax>YMax then YMax := Zmax;
  end;
  if (Choice=3) then
  begin
    if YrMin<Ymin then YMin := YrMin;
    if YrMax>Ymax then Ymax := YrMax;
  end;
  if (Choice=4) then
  begin
    Ymin := YcMin;
    Ymax := YcMax;
  end;
  if (Choice=5) then
  begin
    Ymin := HMin;
    Ymax := HMax;
  end;
  if Choice=6 then
  begin
    Ymin := YcMin;
    if YrMin<YcMin then Ymin := YrMin;
    if Ymin<0 then Ymin:=0;
    Ymax := YcMax;
    if YrMax>YcMax then Ymax := YrMax;
  end;
  if Choice=7 then
  begin
    Ymin := YcMin;
    if YcMin<ZMin then Ymin := ZMin;
    Ymax := YcMax;
    if YcMax<ZMax then Ymax := ZMax;
    Xmin:=Ymin;
    Xmax:=Ymax;
  end;
  if Choice=8 then
  begin
    Xmin := Ymin;
    Xmax := Ymax;
    Ymin := ZMin;
    Ymax := ZMax;
  end;

  if (Ymin=0) and (Ymax=0) then Ymax:=1
     else if Ymin=Ymax then
     begin
       Ymin:=0;
       Ymax:=Ymax+1;
     end;

  FactorX := 1;
  FactorY := 1;
  Ymax:=1.1*Ymax;

  if (Ymin>=0) and (Ymax<0.01) then
  begin
    FactorY:=1000;
    Ymin:=FactorY*Ymin;
    Ymax:=FactorY*Ymax;
  end;
  if (Ymin>=0) and (Ymax<0.1) and (Ymax>0.01) then
  begin
    FactorY:=100;
    Ymin:=FactorY*Ymin;
    Ymax:=FactorY*Ymax;
  end;
  if (Ymin>=0) and (Ymax<1) and (Ymax>0.1) then
  begin
    FactorY:=10;
    Ymin:=FactorY*Ymin;
    Ymax:=FactorY*Ymax;
  end;

 if Ymax<1 then
  begin
    decimY := 2;
    MinY := round (Ymin-0.05);
    MaxY := round (Ymax+0.05);
    ScaleY := MaxY-MinY;
    if ScaleY>10 then ScaleY := (MaxY-MinY) div 2;
  end
  else if Ymax<10 then
  begin
    decimY := 1;
    MinY := round (Ymin-0.5);
    MaxY := round (Ymax+0.5);
    ScaleY := MaxY-MinY;
    if ScaleY>10 then ScaleY := (MaxY-MinY) div 2;
  end
  else if Ymax<25 then
  begin
    decimY := 1;
    MinY := 4*round ((Ymin-2)/4);
    MaxY := 4*round ((Ymax+2)/4);
    ScaleY := (MaxY-MinY) div 4;
  end
  else if Ymax<50 then
  begin
    decimY := 1;
    MinY := 5*round ((Ymin-2.5)/5);
    MaxY := 5*round ((Ymax+2.5)/5);
    ScaleY := (MaxY-MinY) div 5;
  end
  else if Ymax<100 then
  begin
    decimY := 0;
    MinY := 10*round ((Ymin-5)/10);
    MaxY := 10*round ((Ymax+5)/10);
    ScaleY := (MaxY-MinY) div 10;
  end
  else if Ymax<250 then
  begin
    decimY := 0;
    MinY := 25*round ((Ymin-12.5)/25);
    MaxY := 25*round ((Ymax+12.5)/25);
    ScaleY := (MaxY-MinY) div 25;
  end
  else if Ymax<500 then
  begin
    decimY := 0;
    MinY := 50*round ((Ymin-25)/50);
    MaxY := 50*round ((Ymax+25)/50);
    ScaleY := (MaxY-MinY) div 50;
  end
  else if Ymax<1000 then
  begin
    decimY := 0;
    MinY := 100*round ((Ymin-50)/100);
    MaxY := 100*round ((Ymax+50)/100);
    ScaleY := (MaxY-MinY) div 100;
  end
  else if Ymax<2500 then
  begin
    decimY := 0;
    MinY := 250*round ((Ymin-125)/250);
    MaxY := 250*round ((Ymax+125)/250);
    ScaleY := (MaxY-MinY) div 250;
  end
  else if Ymax<5000 then
  begin
    decimY := 0;
    MinY := 500*round ((Ymin-250)/500);
    MaxY := 500*round ((Ymax+250)/500);
    ScaleY := (MaxY-MinY) div 500;
  end
  else if Ymax<10000 then
  begin
    decimY := 0;
    MinY := 1000*round ((Ymin-500)/1000);
    MaxY := 1000*round ((Ymax+500)/1000);
    ScaleY := (MaxY-MinY) div 1000;
  end
  else if Ymax<25000 then
  begin
    decimY := 0;
    MinY := 2500*round ((Ymin-1250)/2500);
    MaxY := 2500*round ((Ymax+1250)/2500);
    ScaleY := (MaxY-MinY) div 2500;
  end
  else if Ymax<50000 then
  begin
    decimY := 0;
    MinY := 5000*round ((Ymin-2500)/5000);
    MaxY := 5000*round ((Ymax+2500)/5000);
    ScaleY := (MaxY-MinY) div 5000;
  end
  else if Ymax<100000 then
  begin
    decimY := 0;
    MinY := 10000*round ((Ymin-5000)/10000);
    MaxY := 10000*round ((Ymax+5000)/10000);
    ScaleY := (MaxY-MinY) div 10000;
  end;

  if Choice=8 then
  begin
    MinX:=round(Ymin-0.5);
    MaxX:=round(Ymax+0.5);
  end;

  if MinY=MaxY then MaxY:=MinY+ 1;

  if (Xmin>0) and (Xmax<0.01) then
  begin
    FactorX:=1000;
    Xmin:=FactorY*Xmin;
    Xmax:=FactorX*Xmax;
  end;
  if (Xmin>0) and (Xmax<0.1) and (Xmax>0.01) then
  begin
    FactorX:=100;
    Xmin:=FactorY*Xmin;
    Xmax:=FactorX*Xmax;
  end;
  if (Xmin>0) and (Xmax<1) and (Xmax>0.1) then
  begin
    FactorX:=10;
    Xmin:=FactorX*Xmin;
    Xmax:=FactorX*Xmax;
  end;

  if Xmax<10 then
  begin
    decimX := 1;
    MinX := round (Xmin-0.5);
    MaxX := round (Xmax+0.5);
    ScaleX := MaxX-MinX;
  end
  else if Xmax<25 then
  begin
    decimX := 1;
    MinX := 4*round ((Xmin-2)/4);
    MaxX := 4*round ((Xmax+2)/4);
    ScaleX := (MaxX-MinX) div 4;
  end
  else if Xmax<50 then
  begin
    decimX := 0;
    MinX := 5*round ((Xmin-2.5)/5);
    MaxX := 5*round ((Xmax+2.5)/5);
    ScaleX := (MaxX-MinX) div 5;
  end
  else if Xmax<100 then
  begin
    decimX := 0;
    MinX := 10*round ((Xmin-5)/10);
    MaxX := 10*round ((Xmax+5)/10);
    ScaleX := (MaxX-MinX) div 10;
  end
  else if Xmax<250 then
  begin
    decimX := 0;
    MinX := 25*round ((2*Xmin-25)/50);
    MaxX := 25*round ((2*Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 25;
  end
  else if Xmax<500 then
  begin
    decimX := 0;
    MinX := 50*round ((Xmin-25)/50);
    MaxX := 50*round ((Xmax+25)/50);
    ScaleX := (MaxX-MinX) div 50;
  end
  else if Xmax<1000 then
  begin
    decimX := 0;
    MinX := 100*round ((Xmin-50)/100);
    MaxX := 100*round ((Xmax+50)/100);
    ScaleX := (MaxX-MinX) div 100;
  end
  else if Xmax<2500 then
  begin
    decimX := 0;
    MinX := 250*round ((2*Xmin-250)/500);
    MaxX := 250*round ((2*Xmax+250)/500);
    ScaleX := (MaxX-MinX) div 250;
  end
  else if Xmax<5000 then
  begin
    decimX := 0;
    MinX := 500*round ((Xmin-250)/500);
    MaxX := 500*round ((Xmax+250)/500);
    ScaleX := (MaxX-MinX) div 500;
  end
  else if Xmax<10000 then
  begin
    decimX := 0;
    MinX := 1000*round ((Xmin-500)/1000);
    MaxX := 1000*round ((Xmax+500)/1000);
    ScaleX := (MaxX-MinX) div 1000;
  end
  else if Xmax<25000 then
  begin
    decimX := 0;
    MinX := 2500*round ((2*Xmin-2500)/5000);
    MaxX := 2500*round ((2*Xmax+2500)/5000);
    ScaleX := (MaxX-MinX) div 2500;
  end
  else if Xmax<50000 then
  begin
    decimX := 0;
    MinX := 5000*round ((Xmin-2500)/5000);
    MaxX := 5000*round ((Xmax+2500)/5000);
    ScaleX := (MaxX-MinX) div 5000;
  end
  else if Xmax<100000 then
  begin
    decimX := 0;
    MinX := 10000*round ((Xmin-5000)/10000);
    MaxX := 10000*round ((Xmax+5000)/10000);
    ScaleX := (MaxX-MinX) div 10000;
  end;

  if ScaleY>10 then begin
     ScaleY := 10;
     DecimY := DecimY+1;
  end;
  if ScaleX>10 then
  begin
    ScaleX := 10;
    DecimX:=DecimX+1;
  end;
  if ScaleY<4 then begin
     ScaleY := 4;
     if DecimY=0 then DecimY := DecimY+1;
  end;
  if ScaleX<4 then
  begin
    ScaleX := 4;
    DecimX:=DecimX+1;
  end;

end;
{-------------}
{end of MaxMin}


procedure OrderData;
{------------------}
label 1;
var ii, jj : integer;
    AuxR : real;
begin
with DMRainOff do
begin
  for ii:=0 to NrOfData-1 do
1:begin
    for jj:=ii+1 to NrOfData-1 do
    begin
      if Xdata[jj]<Xdata[jj-1] then
      begin
        AuxR :=Xdata[jj];
        Xdata[jj]:=Xdata[jj-1];
        Xdata[jj-1]:=AuxR;
        AuxR :=YData[jj];
        YData[jj]:=YData[jj-1];
        YData[jj-1]:=AuxR;
        AuxR :=YrData[jj];
        YrData[jj]:=YrData[jj-1];
        YrData[jj-1]:=AuxR;
        AuxR :=YcData[jj];
        YcData[jj]:=YcData[jj-1];
        YcData[jj-1]:=AuxR;
        AuxR :=ZData[jj];
        ZData[jj]:=ZData[jj-1];
        ZData[jj-1]:=AuxR;
        goto 1;
      end;
    end;
  end;
end; {with DMRainOff do}
end;
{end of OrderData}
{----------------}


{Relative is part of Graphics}
{----------------------------}
procedure Relative (var Choice : byte);
var  ii : integer;
     XdataRel,YdataRel,ZdataRel,YrdataRel,YcDataRel, HdataRel : real;
begin

  with DMRainOff do for ii:=0 to NrOfData-1 do
  begin
    Xdata[ii] := FactorX * Xdata[ii];
    Ydata[ii] := FactorY * Ydata[ii];
    Zdata[ii] := FactorY * Zdata[ii];
    Yrdata[ii] := FactorY * Yrdata[ii];
    Ycdata[ii] := FactorY * Ycdata[ii];
    if Choice=5 then Hdata[ii] := FactorY * Hdata[ii];
    XdataRel := LX*(Xdata[ii]-MinX)/(MaxX-MinX);
    SetLength (RelXdata,ii+1);
    RelXdata[ii] := PosX1+round(XdataRel);
    YdataRel := LY*(Ydata[ii]-MinY)/(MaxY-MinY);
    SetLength (RelYdata,ii+1);
    RelYdata[ii] := PosY2-round(YdataRel)-5;
    if Choice=8 then
    begin
      YdataRel := LX*(Yrdata[ii]-MinX)/(MaxX-MinX);
      RelYdata[ii] := PosX1+round(YdataRel);
    end;
    ZdataRel := LY*(Zdata[ii]-MinY)/(MaxY-MinY);
    SetLength (RelZdata,ii+1);
    RelZdata[ii] := PosY2-round(ZdataRel)-5;
    YrDataRel := LY*(YrData[ii]-MinY)/(MaxY-MinY);
    SetLength (RelYrData,ii+1);
    RelYrData[ii] := PosY2-round(YrDataRel)-5;
    YcDataRel := LY*(YcData[ii]-MinY)/(MaxY-MinY);
    SetLength (RelYcData,ii+1);
    RelYcData[ii] := PosY2-round(YcDataRel)-5;
    if Choice=5 then
    begin
      HdataRel := LY*(Hdata[ii]-MinY)/(MaxY-MinY);
      SetLength (RelHdata,ii+1);
      RelHdata[ii] := PosY2-round(HdataRel)-5;
    end;
  end;
  if Choice=8 then for ii:=0 to 10 do
  begin
    XpointRel := LX*(Xpoint[ii+1]-MinX)/(MaxX-MinX);
    RelXpoint[ii+1] := PosX1+round(XpointRel);
    QuadrRel := LY*(Quadr[ii+1]-MinY)/(MaxY-MinY);
    RelQuadr[ii+1] := PosY2-round(QuadrRel)-5;
  end;

end;
{---------------}
{end of Relative}


{Legends is part of Graphics}
{---------------------------}
procedure Legends (var Choice : byte);
begin

  if (Choice=1) or (Choice=3) then
  begin
    LegendY := 'Discharge/runoff (mm/t)';
    if FactorY=10 then LegendY := 'Discharge or runoff * 10';
    if FactorY=100 then LegendY := 'Discharge or runoff * 100';
    if FactorY=1000 then LegendY := 'Discharge or runoff * 1000';
  end;
  if (Choice=2) or (Choice=4) then
  begin
    LegendY := 'Rain/Recharge (mm/t)';
    if FactorY=10 then LegendY := 'Rain or Recharge * 10';
    if FactorY=100 then LegendY := 'Rain or Recharge * 100';
    if FactorY=1000 then LegendY := 'Rain or Recharge * 1000';
  end;
  if Choice=5 then
  begin
    if DMrainoff.Drainage then
       LegendY:='Water table height (predicted, m)'
    else
       LegendY:=' Reservoir storage predicted (mmm)';
    if FactorY=10 then
    if DMrainoff.Drainage then
       LegendY:='Water table height (m) * 10'
    else
       LegendY:=' Reservoir storage (mm) * 10';
    if FactorY=100 then
    if DMrainoff.Drainage then
       LegendY:='Water table height (m) * 100'
    else
      LegendY:=' Reservoir storage (mm) * 100';
  end;
  if Choice=6 then
  begin
     LegendY := 'Alpha value';
     LegendY1 := '  o  observed';
     LegendY2 := ' --- calculated';
     if FactorY=10 then LegendY := 'Alpha * 10';
     if FactorY=100 then LegendY := 'Alpha * 100';
     if FactorY=1000 then LegendY := 'Alpha * 1000';
  end;
  if Choice<6 then
  begin
    LegendX := 'Time';
    if FactorX=10 then LegendX := 'Time * 10';
    if FactorX=100 then LegendX := 'Time * 100';
    if FactorX=1000 then LegendX := 'Time * 1000';
  end;
  if (Choice=6) then
  begin
    LegendX := 'Discharge/Runoff (mm/t)';
    if FactorX=10 then LegendX := 'Discharge or Runoff * 10';
    if FactorX=100 then LegendX := 'Discharge or Runoff * 100';
    if FactorX=1000 then LegendX := 'Discharge or Runoff * 1000';
  end;
  if Choice=7 then
  begin
    LegendY := 'Runoff calculated (mm/t)';
    LegendY1 := ' ---  Obs = Calc';
    if FactorY=10 then LegendY := 'Runoff calculated * 10';
    if FactorY=100 then LegendY := 'Runoff calculated * 100';
    if FactorY=1000 then LegendY := 'Runoff calculated * 1000';
    LegendX := 'Runoff observed';
    if FactorX=10 then LegendX := 'Runoff observed * 10';
    if FactorX=100 then LegendX := 'Runoff observed * 100';
    if FactorX=1000 then LegendX := 'Runoff observed * 1000';
  end;
  if ((Choice=1) or (Choice=2)) then
  begin
    LegendY1 := ' o  observed';
    LegendY2 := '--- calculated';
  end;
  if (Choice=3) or (Choice=4) or (Choice=5) then
  begin
    LegendY1 := ' o  Rain/irrigation (mm/t)';
    LegendY2 := '--- Recharge (mm/t)';
  end;
  if Choice=6 then
  begin
    LegendY1 := ' o   observed';
    LegendY2 := '---  calculated';
  end;
  if Choice=8 then
  begin
    LegendY := 'Discharge observed';
    LegendY1 := ' o   observed';
    LegendY2 := '---  trend line';
    LegendY3 := '---  quadr. trend';
    LegendX := 'Recharge calculated';
  end;

end;
{end of Legends}
{--------------}


end.


